<template>
  <div>
    <div class="py-3 px-5 font-bold text-xl mb-2 border-b-2">Line chart</div>
    <div class="flex items-center justify-end mb-4">
      <button 
        @click="showOddYears = !showOddYears"
        :class="{'bg-blue-500 text-white': showOddYears, 'bg-gray-300 text-gray-700': !showOddYears}"
        class="px-4 py-2 my-2 rounded-lg shadow-md focus:outline-none"
      >
        {{ showOddYears ? 'Mostrar anos ímpares' : 'Ocultar anos ímpares' }}
      </button>
    </div>
    <Bar
      id="my-chart-id"
      :options="chartOptions"
      :data="filteredChartData"
    />
  </div>
</template>

<script>
import { Bar } from 'vue-chartjs'
import { Chart as ChartJS, Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale } from 'chart.js'

ChartJS.register(Title, Tooltip, Legend, BarElement, CategoryScale, LinearScale)

export default {
  name: 'BarChart',
  components: { Bar },
  props: {
    sales: {
      type: Array,
      required: true
    }
  },
  data() {
    return {
      showOddYears: false
    };
  },
  computed: {
    chartData() {
      const labels = this.sales.map(sale => sale.year);
      const data = this.sales.map(sale => sale.sales);
      const backgroundColor = 'rgba(99, 102, 241, 1)';

      return {
        labels,
        datasets: [
          {
            label: 'Vendas',
            data,
            backgroundColor
          }
        ]
      };
    },
    filteredChartData() {
      if (this.showOddYears) {
        // filter out sales with odd years
        const filteredSales = this.sales.filter(sale => sale.year % 2 === 0);
        const labels = filteredSales.map(sale => sale.year);
        const data = filteredSales.map(sale => sale.sales);
        const backgroundColor = 'lightgreen';

        return {
          labels,
          datasets: [
            {
              label: 'Vendas',
              data,
              backgroundColor
            }
          ]
        };
      } else {
        return this.chartData;
      }
    },
    chartOptions() {
      return {
        responsive: true,
        scales: {
          yAxes: [
            {
              ticks: {
                beginAtZero: true
              }
            }
          ]
        }
      }
    }
  }
}
</script>
